Aggregation Technologies

‌‌
The Aggregation Technologies endpoint will provide you with a list of the most popular technologies websites use alongside the technologies you specify. Alternatively, you can specify technology categories or groups to obtain wider stats.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task.

Description of the fields for setting a task:

Field nameTypeDescription
groupstring

id of the target technology group
required field if you don't specify technology, category or keyword
at least one field (group, category, keyword, technology) must be set
you can find the full list of technology group ids on this page
example:
"marketing"

categorystring

id of the target technology category
required field if you don't specify group, keyword or technology
at least one field (group, category, keyword, technology) must be set
you can find the full list of technology category ids on this page
example:
"crm"

technologystring

target technology
required field if you don't specify group, keyword or category
at least one field (group, category, keyword, technology) must be set
you can find the full list of technologies on this page
example:
"Salesforce"

keywordstring

target keyword in the domain's meta keywords
required field if you don't specify group, category or technology
at least one field (group, category, keyword, technology) must be set
UTF-8 encoding
example:
"seo"learn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

modestring

search mode
optional field
possible search mode types:
as_is - search for results exactly matching the specified group ids, category ids, or technology names
entry - search for results matching a part of the specified group ids, category ids, or technology names
default value: as_is

filtersarray

array of results filtering parameters
optional field
you can add several filters at once (8 filters maximum)
you should set a logical operator and, or between the conditions
the following operators are supported:
<, <=, >, >=, =, <>, in, not_in, like,not_like
you can use the % operator with like and not_like to match any string of zero or more characters
you can use the following parameters to filter the results: domain_rank, last_visited, country_iso_code, language_code, content_language_code
Note: all filtering parameters are taken from the domain_technology_item of the domain_technologies endpoint;
example:
[["country_iso_code","=","US"],
"and",
["domain_rank",">",800]]
for more information about filters, please refer to Domain Analytics Technologies API - Filters

order_byarray

results sorting rules
optional field
you can use the following values to sort the results: groups_count, categories_count, technologies_count
possible sorting types:
asc - results will be sorted in the ascending order
desc - results will be sorted in the descending order
you should use a comma to set up a sorting type
example:
["groups_count,desc"]
note that you can set no more than three sorting rules in a single request
you should use a comma to separate several sorting rules
example:
["groups_count,desc","technologies_count,desc"]
default value:
["groups_count,desc","categories_count,desc","technologies_count,desc"]

internal_groups_list_limitinteger

maximum number of returned technology groups
optional field
you can use this field to limit the number of items with identical "group" in the results
default value: 5
minimum value: 1
maximum value: 10000

internal_categories_list_limitinteger

maximum number of returned technology categories within the same group
optional field
you can use this field to limit the number of items with identical "category" in the results
default value: 5
minimum value: 1
maximum value: 10000

internal_technologies_list_limitinteger

maximum number of returned technologies within the same category
optional field
you can use this field to limit the number of items with identical "technology" in the results
default value: 10
minimum value: 1
maximum value: 10000

internal_list_limitinteger

maximum number of items with identical "category", "group", and "technology"
optional field
if you use this field, the values specified in internal_groups_list_limit, internal_categories_list_limit and internal_technologies_list_limit will be ignored;
you can use this field to limit the number of items with identical "category", "group", or "technology"
default value: 10
minimum value: 1
maximum value: 10000

limitinteger

the maximum number of returned technologies
optional field
default value: 100
maximum value: 10000

offsetinteger

offset in the results array of returned domains
optional field
default value: 0
maximum value: 9999
if you specify the 10 value, the first ten technologies in the results array will be omitted and the data will be provided for the successive technologies

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        total_countinteger

total amount of results in our database relevant to your request

        items_countinteger

the number of results returned in the items array

        typeobject

type of element = ‘aggregation_technologies_item’

            groupstring

technology group id

            categorystring

technology category id

            technologystring

technology name

            groups_countinteger

technology groups count
number of domains that match the parameters you specified and are using technologies from the indicated group

            categories_countinteger

technology categories count
number of domains that match the parameters you specified and are using technologies from the indicated category

            technologies_countinteger

technologies count
number of domains that match the parameters you specified and are using the indicated technology


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/domain_analytics/technologies/aggregation_technologies/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
    {
        "mode": "entry",
        "technology": "Nginx",
        "keyword": "WordPress",
        "filters": [
            [
                "country_iso_code",
                "=",
                "US"
            ],
            "and",
            [
                "domain_rank",
                ">",
                800
            ]
        ],
        "order_by": [
            "groups_count,desc"
        ],
        "limit": 10
    }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// You can set only one task at a time
$post_array[] = array(
	"technology" => "Nginx",
	"keyword" => "WordPress",
	"filters" => [
		[
			"country_iso_code",
			"=",
			"US"
		],
		"and",
		[
			"domain_rank",
			">",
			800
		]
	],
	"order_by" => ["groups_count,desc"],
	"limit" => 10
);
try {
	// POST /v3/domain_analytics/technologies/aggregation_technologies/live
	$result = $client->post('/v3/domain_analytics/technologies/aggregation_technologies/live', $post_array);
	print_r($result);
	// do something with post result
} catch (RestClientException $e) {
	echo "n";
	print "HTTP code: {$e->getHttpCode()}n";
	print "Error code: {$e->getCode()}n";
	print "Message: {$e->getMessage()}n";
	print  $e->getTraceAsString();
	echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "url": "https://dataforseo.com/blog",
  "enable_javascript": true,
  "custom_js": "meta = {}; meta.url = document.URL; meta;"
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/domain_analytics/technologies/aggregation_technologies/live',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# You can set only one task at a time
post_data[len(post_data)] = dict(
    technology = "Nginx",
    keyword = "WordPress",
    filters = [
            [
                "country_iso_code",
                "=",
                "US"
            ],
            "and",
            [
                "domain_rank",
                ">",
                800
            ]
    ],
    order_by = ["groups_count,desc"],
    limit = 10
)
# POST /v3/domain_analytics/technologies/aggregation_technologies/live
response = client.post("/v3/domain_analytics/technologies/aggregation_technologies/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task domain_analytics_technologies_aggregation_technologies_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // You can set only one task at a time
            postData.Add(new
            {
                technology = "Nginx",
                keyword = "WordPress",
                filters = new object[]
                {
                    new object[] { "country_iso_code", "=", "US" },
                    "and",
                    new object[] { "domain_rank", ">", 800 }
                },
                order_by = new object[] { "groups_count,desc" },
                limit = 10
            });
            // POST /v3/domain_analytics/technologies/aggregation_technologies/live
            var taskPostResponse = await httpClient.PostAsync("/v3/domain_analytics/technologies/aggregation_technologies/live", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20220926",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.2280 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "09261732-0001-0491-1000-7d53c0c51601",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.0865 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "domain_analytics",
        "technologies",
        "aggregation_technologies",
        "live"
      ],
      "data": {
        "api": "domain_analytics",
        "function": "aggregation_technologies",
        "se": "technologies",
        "technology": "Nginx",
        "keyword": "WordPress",
        "filters": [
          [
            "country_iso_code",
            "=",
            "US"
          ],
          "and",
          [
            "domain_rank",
            ">",
            800
          ]
        ],
        "order_by": [
          "groups_count,desc"
        ],
        "limit": 10
      },
      "result": [
        {
          "total_count": 30,
          "items_count": 10,
          "offset": 0,
          "items": [
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "web_servers",
              "technology": "Nginx",
              "groups_count": 32,
              "categories_count": 9,
              "technologies_count": 8
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "web_servers",
              "technology": "Amazon EC2",
              "groups_count": 32,
              "categories_count": 9,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "databases",
              "technology": "MySQL",
              "groups_count": 32,
              "categories_count": 8,
              "technologies_count": 7
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "databases",
              "technology": "Percona",
              "groups_count": 32,
              "categories_count": 8,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "reverse_proxies",
              "technology": "Nginx",
              "groups_count": 32,
              "categories_count": 8,
              "technologies_count": 8
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "paas",
              "technology": "Acquia Cloud Platform",
              "groups_count": 32,
              "categories_count": 3,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "paas",
              "technology": "Amazon Web Services",
              "groups_count": 32,
              "categories_count": 3,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "paas",
              "technology": "WordPress.com",
              "groups_count": 32,
              "categories_count": 3,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "caching",
              "technology": "Varnish",
              "groups_count": 32,
              "categories_count": 2,
              "technologies_count": 1
            },
            {
              "type": "aggregation_technologies_item",
              "group": "servers",
              "category": "caching",
              "technology": "WP Rocket",
              "groups_count": 32,
              "categories_count": 2,
              "technologies_count": 1
            }
          ]
        }
      ]
    }
  ]
}